datablock ParticleData(CLSmokeExplosionParticle)
{
	dragCoefficient			= 10;
	gravityCoefficient		= 0.0;
	inheritedVelFactor		= 0.0;
	constantAcceleration	= 0.0;
	spinRandomMin			= -600;
	spinRandomMax			= 600;
	lifetimeMS				= 1000;
	lifetimeVarianceMS		= 100;

	textureName	= "base/data/particles/cloud";

	useinvAlpha	= 1;
	sizes[0]	= 0.8;
	sizes[1]	= 1.5;
	times[0]	= 0.0;
	times[1]	= 1.0;
	colors[0]	= "0.2 0.2 0.2 0.8";
	colors[1]	= "0.2 0.2 0.2 0.0";
};

datablock ParticleEmitterData(CLSmokeExplosionEmitter)
{
	ejectionPeriodMS	= 2;
	periodVarianceMS	= 1;
	ejectionVelocity	= 0.1;
	velocityVariance	= 0.1;
	ejectionOffset		= 1.0;
	thetaMin			= 0;
	thetaMax			= 180;
	phiReferenceVel		= 0;
	phiVariance			= 360;
	overrideAdvance		= false;
	particles	= "CLSmokeExplosionParticle";
	uiname		= "CL Smoke Explosion";
};

datablock ParticleData(CLSmokeTrailParticle)
{
	dragCoefficient			= 10;
	gravityCoefficient		= 0.1;
	inheritedVelFactor		= 0.0;
	constantAcceleration	= 0.0;
	spinRandomMin			= -600;
	spinRandomMax			= 600;
	lifetimeMS				= 300;
	lifetimeVarianceMS		= 50;

	textureName	= "base/data/particles/cloud";

	useinvAlpha	= 1;
	sizes[0]	= 0.25;
	sizes[1]	= 0.10;
	times[0]	= 0.0;
	times[1]	= 1.0;
	colors[0]	= "0.2 0.2 0.2 0.8";
	colors[1]	= "0.2 0.2 0.2 0";
};

datablock ParticleEmitterData(CLSmokeTrailEmitter)
{
	ejectionPeriodMS	= 2;
	periodVarianceMS	= 1;
	ejectionVelocity	= 0.1;
	velocityVariance	= 0.1;
	ejectionOffset		= 0.2;
	thetaMin			= 0;
	thetaMax			= 180;
	phiReferenceVel		= 0;
	phiVariance			= 360;
	overrideAdvance		= false;

	particles	= "CLSmokeTrailParticle";
	uiname		= "CL Smoke Trail";
};

datablock ExplosionData(CLSmokeExplosion)
{
	lifeTimeMS	= 200;

	//soundProfile	= CLBladeHitSound;

	particleEmitter	= CLSmokeExplosionEmitter;
	particleDensity	= 20;
	particleRadius	= 0.2;

	faceViewer		= true;
	explosionScale	= "1 1 1";

	shakeCamera			= true;
	camShakeFreq		= "20.0 22.0 20.0";
	camShakeAmp			= "1.0 1.0 1.0";
	camShakeDuration	= 2.0;
	camShakeRadius		= 25.0;

	lightStartRadius	= 0;
	lightEndRadius		=10;
	lightStartColor		= "0.4 1.0 0.4";
	lightEndColor		= "0 0 0";
};

datablock ProjectileData(CLSmokeProjectile)
{
	directDamage		= 1;
	explosion			= CLSmokeExplosion;
	particleEmitter		= CLSmokeTrailEmitter;
	ImpactImpulse		= 1700;
	verticleImpulse		= 700;

	muzzleVelocity		= 70;
	velInheritFactor	= 0;

	armingDelay			= 0;
	lifetime			= 1000;
	fadeDelay			= 70;
	bounceElasticity	= 0;
	bounceFriction		= 0;
	isBallistic			= false;
	gravityMod			= 0.0;

	hasLight	= true;
	lightRadius	= 5.0;
	lightColor	= "0 0 0";
};

datablock ItemData(CLSmokeItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "base/data/shapes/empty.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "William Smoke";
	iconName = "./icon_xana";
	doColorShift = true;
	colorShiftColor = "0.0 0.0 0.0 1.000";

	image = CLSmokeImage;
	canDrop = true;
};

datablock ShapeBaseImageData(CLSmokeImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = true;

	mountPoint = 0;
	offset = "0 0 0";

	correctMuzzleVector = false;

	eyeOffset = "0.7 1.2 -0.25";

	className = "WeaponImage";

	item = CLSmokeItem;
	ammo = " ";
	projectile = CLSmokeProjectile;
	projectileType = Projectile;

	melee = false;
	doRetraction = false;
	armReady = true;

	doColorShift = false;
	colorShiftColor = "0.0 0.0 0.0 1.000";

	minShotTime = 1500;

	stateName[0]				= "Activate";
	stateTimeoutValue[0]		= 0.2;
	stateTransitionOnTimeout[0]	= "Ready";
	stateEmitter[0]				= "CLSmokeTrailEmitter";
	stateEmitterTime[0]			= 0.2;
	stateSound[0]				= "WeaponSwitchSound";

	stateName[1]					= "Ready";
	stateEmitter[1]					= "CLSmokeTrailEmitter";
	stateEmitterTime[1]				= 0.2;
	stateTransitionOnTriggerDown[1]	= "Fire";
	stateAllowImageChange[1]		= true;
	stateTransitionOnTimeout[1]		= "Ready";
	stateWaitForTimeout[1]			= false;
	stateTimeoutValue[1]			= 0.2;

	stateName[2]				= "Fire";
	stateTransitionOnTimeout[2]	= "StopFire";
	stateEmitter[2]				= "CLSmokeTrailEmitter";
	stateEmitterTime[2]			= 0.1;
	stateTimeoutValue[2]		= 0.1;
	stateFire[2]				= true;
	stateAllowImageChange[2]	= false;
	stateSequence[2]			= "Fire";
	stateScript[2]				= "onFire";
	stateWaitForTimeout[2]		= true;

	stateName[3]				= "StopFire";
	stateTransitionOnTimeout[3]	= "Ready";
	stateTimeoutValue[3]		= 1.5;
	stateAllowImageChange[3]	= false;
	stateWaitForTimeout[3]		= true;
	stateSequence[3]			= "StopFire";
	stateScript[3]				= "onStopFire";
};

datablock ParticleData(CLParalyzeParticle)
{
	dragCoefficient		= 5;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;

	spinRandomMin		= -300;
	spinRandomMax		= 300;
	spinSpeed			= 10;

	lifetimeMS			= 400;
	lifetimeVarianceMS	= 50;

	textureName	= "base/data/particles/cloud";

	useinvAlpha	= 1;

	sizes[0]	= 0.25;
	sizes[1]	= 0.40;
	times[0]	= 0.0;
	times[1]	= 1.0;
	colors[0]	= "0.3 0.3 0.3 0.8";
	colors[1]	= "0.1 0.1 0.1 0";
};

datablock ParticleEmitterData(CLParalyzeEmitter)
{
	ejectionPeriodMS	= 10;
	periodVarianceMS	= 0;
	ejectionVelocity	= 6;
	velocityVariance	= 2;

	ejectionOffset	= 1.0;
	thetaMin		= 0;
	thetaMax		= 180;
	phiReferenceVel	= 0;
	phiVariance		= 360;
	overrideAdvance	= false;

	particles	= "CLParalyzeParticle";
	uiname		= "CL Paralysis";
};

datablock ShapeBaseImageData(CLParalysisImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = true;

	mountPoint = 5;
	offset = "0 0 0";

	correctMuzzleVector = false;

	eyeOffset = "0.7 1.2 -0.25";

	className = "WeaponImage";

	item = CLSmokeItem;
	ammo = " ";

	melee = false;
	doRetraction = false;
	armReady = false;

	stateName[0]				= "Activate";
	stateTimeoutValue[0]		= 4.0;
	stateTransitionOnTimeout[0]	= "Done";
	stateEmitter[0]				= "CLParalyzeEmitter";
	stateEmitterTime[0]			= 2.0;
	stateEmitterNode[0]			= "mountPoint";

	stateName[1]	= "Done";
	stateScript[1]	= "onDone";
};

function CLSmokeProjectile::Damage(%this,%obj,%col,%fade,%pos,%normal)
{
	if(%col.isInvincible)
		return;
	%col.CLParalyze();
	Parent::Damage(%this,%obj,%col,%fade,%pos,%normal);
}

function CLParalyzeImage::onDone(%this, %obj, %slot)
{
	%obj.unMountImage(%slot);
}

function player::CLParalyze(%this)
{
	if(%this.client.camera.mode = "Orbit")
		return;

	if(isEventPending(%this.unStunSchedule))
	{
		cancel(%this.unStunSchedule);
		%this.unStunSchedule = %this.schedule(4000, unStun);
		return;
	}
	%this.mountImage(CLParalysisImage, 3);
	%this.playThread(3, death1);
	%this.schedule(4000, playThread, 3, root);
	if(isObject(%this.client))
	{
		%transform = %this.getTransform();
		%this.client.camera.setOrbitMode(%this, %transform, 0.5, 8, 8, 1);
		%this.client.camera.mode = "Orbit";
		%this.client.setControlObject(%this.client.camera);
		%this.client.centerprint("<color:a0a0a0>Your blood runs cold...<br>You're paralyzed!", 4);
	}
	%this.unMountImage(0);
	%this.isBatStunned = 1;
	%this.unStunSchedule = %this.schedule(4000, unStun);
}

function aiPlayer::CLParalyze(%this)
{
	if(isEventPending(%this.unStunSchedule))
	{
		cancel(%this.unStunSchedule);
		%this.unStunSchedule = %this.schedule(4000, CLunStun);
		return;
	}

	if(isObject(%this.getMoveObject()))
	{
		%this.schedule(4000, setMoveObject, %this.getMoveObject());
	}
	else if(vectorDist(%this.getMoveDestination(), %this.getPosition()) < 5)
	{
		%this.schedule(4000, setMoveDestination, %this.getMoveDestination());
	}

	%this.stop();
	%this.stopHoleLoop(0);
	%this.playThread(3, death1);
	%this.mountImage(CLParalysisImage, 3);
	%this.setImageTrigger(0, 0);

	%this.unStunSchedule = %this.schedule(4000, CLunStun);
}

function aiPlayer::CLunStun(%this)
{
	%this.startHoleLoop();
	%this.playThread(3, undo);
}
