// From the TF2 scout pack by Space Guy, Azerath and Racer

datablock ParticleData(StunRingParticle)
{
   dragCoefficient      = 8;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 100;
   lifetimeVarianceMS   = 0;
   textureName          = "base/data/particles/star1";
   spinSpeed      = 500.0;
   spinRandomMin      = -500.0;
   spinRandomMax      = 500.0;
   colors[0]     = "1 1 0.0 0.9";
   colors[1]     = "0.9 0.0 0.0 0.0";
   sizes[0]      = 0.2;
   sizes[1]      = 0;

   useInvAlpha = false;
};

datablock ParticleEmitterData(StunEmitter)
{
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.5;
   thetaMin         = 90;
   thetaMax         = 90.1;
   phiVariance      = 0;
   overrideAdvance = false;
   particles = "StunRingParticle";

   ejectionPeriodMS = 3;
   phiReferenceVel  = 60480;

   uiName = "Emote - Stun";
};

datablock ShapeBaseImageData(StunImage)
{
   shapeFile = "base/data/shapes/empty.dts";
   emap = false;

   mountPoint = $HeadSlot;
   rotation = "1 0 0 -90";
   offset = "0 0 0.5";

   stateName[0]               = "Ready";
   stateTransitionOnTimeout[0]      = "FireA";
   stateTimeoutValue[0]         = 0.01;

   stateName[1]               = "FireA";
   stateTransitionOnTimeout[1]      = "FireA";
   stateWaitForTimeout[1]         = True;
   stateTimeoutValue[1]         = 10000;
   stateEmitter[1]               = StunEmitter;
   stateEmitterTime[1]            = 10000;
};

function Player::unStun(%this)
{
   if(%this.getState() $= "Dead")
      return;

   if(%this.getMountedImage(2) == StunImage.getID())
      %this.unMountImage(2);

   %this.playThread(2,undo);

   %this.schedule(500,unStun2);
}

function Player::unStun2(%this)
{
   %this.isBatStunned = 0;
   if(isObject(%this.client) && %this.getState() !$= "Dead")
   {
		 	%this.client.camera.mode = "Observer";
      %this.client.setcontrolobject(%this);
      if(%this.currTool != -1)
         servercmdUseTool(%this.client,%this.currTool);
   }
}
